"use strict";
this.name        = "tugdrone";
this.author      = "Norby";
this.copyright   = "2013 Norbert Nagy";
this.licence     = "CC BY-NC-SA 3.0";
this.description = "Tug Drone can tow instead of you.";
this.version     = "0.9";

this.$TugDrone_Distance = 0;
this.$TugDrone_Sound = null;
this.$TugDrone_Timer = null;
this.$TugDrone_Timer2 = null;
this.$TugDrone_Target = null;


this.startUp = function() {
	this.$TugDrone_Sound = new SoundSource;
	this.$TugDrone_Sound.sound = "witchabort.ogg"; //sound if cannot start
	this.$TugDrone_Sound.loop = false;
	this.$TugDrone_Sound.repeatCount = 1;
}

this.shipCollided = function(otherShip) {
        if( this.$TugDrone_Target && this.$TugDrone_Target.isValid
                && otherShip == this.$TugDrone_Target )
                this.$TugDrone_Hit(); //payout
}

this.entityDestroyed = function() {
	if( this.$TugDrone_Timer ) {
		this.$TugDrone_Timer.stop();
		delete this.$TugDrone_Timer;
	}
	if( this.$TugDrone_Timer2 ) {
		this.$TugDrone_Timer2.stop();
		delete this.$TugDrone_Timer2;
	}
	if( this.$TugDrone_Target && this.$TugDrone_Target.isValid
		&& this.$TugDrone_Distance < 300 ) //need saved distance due to this.ship is invalid when destroyed
		this.$TugDrone_Hit(); //within 300m assuming to hit the target, go to payout
}

this.shipSpawned = function() {
	var ship = player.ship.target;
	if( !ship ) {
		player.ship.awardEquipment("EQ_TUGDRONE_MISSILE");
		player.consoleMessage("Tug Drone cannot start: need more exact aim",5);
		this.ship.remove(true); //remove drone
		this.$TugDrone_Sound.play();
//		log("TugDrone", "No target");
	} else if( ship.isValid && ship.isDerelict &&
		player.ship.position.distanceTo( ship.position ) < player.ship.scannerRange ) {
//		this.$TugDrone_Timer = new Timer(this, this.$TugDrone_Hit, 10);//debug: payout at max. 10 sec
		this.$TugDrone_Timer2 = new Timer(this, this.$TugDrone_Timed2, 0, 0.25);//distance meter
		player.consoleMessage("Tug Drone launched.",3);
		this.$TugDrone_Target = ship;
//		log("TugDrone", "Launched to "+ship.displayName+" "+ship);
	} else {
		player.ship.awardEquipment("EQ_TUGDRONE_MISSILE");
		player.consoleMessage("Tug Drone cannot start: need derelict ship in scanner range",5);
		this.ship.remove(true); //remove drone
		this.$TugDrone_Sound.play();
//		log("TugDrone", "Not launched to "+ship);
	}
}

this.$TugDrone_Hit = function() {
	var ship = this.$TugDrone_Target;
	if( this.$TugDrone_Timer ) {
		this.$TugDrone_Timer.stop();
		delete this.$TugDrone_Timer;
	}
	if( this.$TugDrone_Timer2 ) {
		this.$TugDrone_Timer2.stop();
		delete this.$TugDrone_Timer2;
	}
	if( ship && ship.isValid && ship.isDerelict ) {
		log("TugDrone", "Payout for "+ship.displayName+" "+ship);
		this.ship.remove(true); //remove drone
		worldScripts["towbar"].$Towbar_Bounty( ship ); //if a missile hit the player after eject
		worldScripts["towbar"].$Towbar_Payout( ship ); //will remove the target ship
	}
}

this.$TugDrone_Timed2 = function() { //distance meter
	if( this.$TugDrone_Target && this.$TugDrone_Target.isValid && this.ship && this.ship.isValid ) {//save distance
		this.$TugDrone_Distance = this.ship.position.distanceTo( this.$TugDrone_Target.position );
//		log("TugDrone", this.$TugDrone_Distance+"m from target: "+ship);
	}
}